#include "projet.h"
#include "form1.h"

#include <Inventor/Qt/SoQt.h>

#include <qapplication.h>
#include <q3mainwindow.h>
#include <qmenubar.h>
#include <q3popupmenu.h>
#include <qvariant.h>
#include <qpoint.h>
#include <qdialog.h>
#include <qlcdnumber.h>
#include <qpushbutton.h>
#include <qradiobutton.h>
#include <qlineedit.h>
#include <qcheckbox.h>
#include <qslider.h>



IVLoader *iv;
Form1 *form1;

int main(int argc, char** argv)
{
  // Cration d'une application Qt
  QApplication app(argc,argv);

  Q3MainWindow* mw= new Q3MainWindow();
  IVLoader ivlo(mw);
  iv = &ivlo;

  iv->matiere = new SoMaterial;

  iv->top = new SoSeparator;

  iv->item_base = new SoSeparator;
  iv->item_translation = new SoTranslation;
  iv->item = new SoSeparator;

  iv->plateau_base = new SoSeparator;
  iv->plateau_translation = new SoTranslation;
  iv->plateau = new SoSeparator;

  iv->bottom = new SoSeparator;
  iv->bottom_translation = new SoTranslation;
  iv->bottom_base = new SoSeparator;

  iv->biceps1 = new SoSeparator;
  iv->biceps1_translation = new SoTranslation;
  iv->biceps1_base = new SoSeparator;
  iv->biceps1_repere = new SoSeparator;
  iv->biceps1_rotor = new SoRotation;

  iv->avantbras1 = new SoSeparator;
  iv->avantbras1_translation = new SoTranslation;
  iv->avantbras1_base = new SoSeparator;
  iv->avantbras1_repere = new SoSeparator;
  iv->avantbras1_rotor = new SoRotation;
  iv->avantbras1g_base = new SoSeparator;
  iv->avantbras1g_translation = new SoTranslation;
  iv->avantbras1g_rotor2 = new SoRotation;
  iv->avantbras1g = new SoSeparator;
  iv->avantbras1d_base = new SoSeparator;
  iv->avantbras1d_translation = new SoTranslation;
  iv->avantbras1d_rotor2 = new SoRotation;
  iv->avantbras1d = new SoSeparator;
  iv->avantbras1h_base = new SoSeparator;
  iv->avantbras1h_translation = new SoTranslation;
  iv->avantbras1h = new SoSeparator;
  iv->avantbras1b_base = new SoSeparator;
  iv->avantbras1b_translation = new SoTranslation;
  iv->avantbras1b = new SoSeparator;

  iv->biceps2 = new SoSeparator;
  iv->biceps2_translation = new SoTranslation;
  iv->biceps2_base = new SoSeparator;
  iv->biceps2_repere = new SoSeparator;
  iv->biceps2_init_rotor = new SoRotation;
  iv->biceps2_rotor = new SoRotation;

  iv->avantbras2 = new SoSeparator;
  iv->avantbras2_translation = new SoTranslation;
  iv->avantbras2_base = new SoSeparator;
  iv->avantbras2_repere = new SoSeparator;
  iv->avantbras2_rotor = new SoRotation;
  iv->avantbras2g_base = new SoSeparator;
  iv->avantbras2g_translation = new SoTranslation;
  iv->avantbras2g_rotor2 = new SoRotation;
  iv->avantbras2g = new SoSeparator;
  iv->avantbras2d_base = new SoSeparator;
  iv->avantbras2d_translation = new SoTranslation;
  iv->avantbras2d_rotor2 = new SoRotation;
  iv->avantbras2d = new SoSeparator;
  iv->avantbras2h_base = new SoSeparator;
  iv->avantbras2h_translation = new SoTranslation;
  iv->avantbras2h = new SoSeparator;
  iv->avantbras2b_base = new SoSeparator;
  iv->avantbras2b_translation = new SoTranslation;
  iv->avantbras2b = new SoSeparator;

  iv->biceps3 = new SoSeparator;
  iv->biceps3_translation = new SoTranslation;
  iv->biceps3_base = new SoSeparator;
  iv->biceps3_repere = new SoSeparator;
  iv->biceps3_init_rotor = new SoRotation;
  iv->biceps3_rotor = new SoRotation;

  iv->avantbras3 = new SoSeparator;
  iv->avantbras3_translation = new SoTranslation;
  iv->avantbras3_base = new SoSeparator;
  iv->avantbras3_repere = new SoSeparator;
  iv->avantbras3_rotor = new SoRotation;
  iv->avantbras3g_base = new SoSeparator;
  iv->avantbras3g_translation = new SoTranslation;
  iv->avantbras3g_rotor2 = new SoRotation;
  iv->avantbras3g = new SoSeparator;
  iv->avantbras3d_base = new SoSeparator;
  iv->avantbras3d_translation = new SoTranslation;
  iv->avantbras3d_rotor2 = new SoRotation;
  iv->avantbras3d = new SoSeparator;
  iv->avantbras3h_base = new SoSeparator;
  iv->avantbras3h_translation = new SoTranslation;
  iv->avantbras3h = new SoSeparator;
  iv->avantbras3b_base = new SoSeparator;
  iv->avantbras3b_translation = new SoTranslation;
  iv->avantbras3b = new SoSeparator;iv->avantbras3 = new SoSeparator;

  if (argc > 1) {
    iv->openFile(QString(argv[1]));
  }
  else {
    //camera
    //SoPerspectiveCamera *myCamera = new SoPerspectiveCamera;
    //iv->separator->addChild(myCamera); 
    //lighting
    iv->separator->addChild(new SoDirectionalLight);
    //matiere
    iv->matiere->diffuseColor.setValue(0.5, 0.7, 0.1);
    iv->separator->addChild(iv->matiere);
    //top
    iv->openMember("top.wrl", iv->top, iv->separator);
    //item
    iv->item_base->ref();
    iv->separator->addChild(iv->item_base);
    iv->item_translation->translation = SbVec3f(-2, -0.60, 0);
    iv->item_base->addChild(iv->item_translation);
    iv->openMember("little_monkey.wrl", iv->item, iv->item_base);
    //plateau
    iv->plateau_base->ref();
    iv->separator->addChild(iv->plateau_base);
    iv->plateau_translation->translation = SbVec3f(0, -1.92, 0);
    iv->plateau_base->addChild(iv->plateau_translation);
    iv->openMember("plateau.wrl", iv->plateau, iv->plateau_base);
    //bottom
    iv->bottom_base->ref();
    iv->separator->addChild(iv->bottom_base);
    iv->bottom_translation->translation = SbVec3f(0, -0.9, 0);
    iv->bottom_base->addChild(iv->bottom_translation);
    iv->openMember("bottom.wrl", iv->top, iv->bottom_base);
    //biceps1
    iv->biceps1_base->ref();
    iv->separator->addChild(iv->biceps1_base);
    iv->biceps1_translation->translation = SbVec3f(0.2f, 0, 0);
  iv->biceps1_base->addChild(iv->biceps1_translation);
  iv->openMember("rep.wrl", iv->biceps1_repere, iv->biceps1_base);
  iv->biceps1_base->addChild(iv->biceps1_rotor);
  iv->openMember("biceps_x.wrl", iv->biceps1, iv->biceps1_base);
  //avantbras1
  iv->avantbras1_base->ref();
  iv->biceps1_base->addChild(iv->avantbras1_base);
  iv->avantbras1_translation->translation = SbVec3f(0.345f, -0.029, 0);
  iv->avantbras1_base->addChild(iv->avantbras1_translation);
  iv->openMember("rep.wrl", iv->avantbras1_repere, iv->avantbras1_base);
  iv->avantbras1_base->addChild(iv->avantbras1_rotor);
  iv->avantbras1_base->addChild(iv->avantbras1g_base);
  iv->avantbras1g_translation->translation = SbVec3f(0, 0, -0.050+0.009);
  iv->avantbras1g_base->addChild(iv->avantbras1g_translation);
  iv->avantbras1g_base->addChild(iv->avantbras1g_rotor2);
  iv->openMember("avantbrasgauche_x.wrl", iv->avantbras1g, iv->avantbras1g_base);
  iv->avantbras1_base->addChild(iv->avantbras1d_base);
  iv->avantbras1d_translation->translation = SbVec3f(0, 0, +0.050+0.009);
  iv->avantbras1d_base->addChild(iv->avantbras1d_translation);
  iv->avantbras1d_base->addChild(iv->avantbras1d_rotor2);
  iv->openMember("avantbrasdroit_x.wrl", iv->avantbras1d, iv->avantbras1d_base);
  iv->avantbras1_base->addChild(iv->avantbras1h_base);
  iv->avantbras1h_translation->translation = SbVec3f(0, -0.03, 0.009);
  iv->avantbras1h_base->addChild(iv->avantbras1h_translation);
  iv->openMember("avantbrashaut_x.wrl", iv->avantbras1h, iv->avantbras1h_base);
  iv->avantbras1_base->addChild(iv->avantbras1b_base);
  iv->avantbras1b_translation->translation = SbVec3f(0, -0.77, 0.009);
  iv->avantbras1b_base->addChild(iv->avantbras1b_translation);
  iv->openMember("avantbrasbas_x.wrl", iv->avantbras1b, iv->avantbras1b_base);


  //biceps2
  iv->biceps2_base->ref();
  iv->separator->addChild(iv->biceps2_base);
  iv->biceps2_init_rotor->rotation.setValue(SbVec3f(0, 1, 0),2.0943951f);
  iv->biceps2_base->addChild(iv->biceps2_init_rotor);
  iv->biceps2_translation->translation = SbVec3f(0.2f, 0, 0);
  iv->biceps2_base->addChild(iv->biceps2_translation);
  iv->biceps2_base->addChild(iv->biceps2_rotor);
  iv->openMember("rep.wrl", iv->biceps2_repere, iv->biceps2_base);
  iv->openMember("biceps_x.wrl", iv->biceps2, iv->biceps2_base);
  //avantbras2
  iv->avantbras2_base->ref();
  iv->biceps2_base->addChild(iv->avantbras2_base);
  iv->avantbras2_translation->translation = SbVec3f(0.345f, -0.029, 0);
  iv->avantbras2_base->addChild(iv->avantbras2_translation);
  iv->openMember("rep.wrl", iv->avantbras2_repere, iv->avantbras2_base);
  iv->avantbras2_base->addChild(iv->avantbras2_rotor);
  iv->avantbras2_base->addChild(iv->avantbras2g_base);
  iv->avantbras2g_translation->translation = SbVec3f(0, 0, -0.050+0.009);
  iv->avantbras2g_base->addChild(iv->avantbras2g_translation);
  iv->avantbras2g_base->addChild(iv->avantbras2g_rotor2);
  iv->openMember("avantbrasgauche_x.wrl", iv->avantbras2g, iv->avantbras2g_base);
  iv->avantbras2_base->addChild(iv->avantbras2d_base);
  iv->avantbras2d_translation->translation = SbVec3f(0, 0, +0.050+0.009);
  iv->avantbras2d_base->addChild(iv->avantbras2d_translation);
  iv->avantbras2d_base->addChild(iv->avantbras2d_rotor2);
  iv->openMember("avantbrasdroit_x.wrl", iv->avantbras2d, iv->avantbras2d_base);
  iv->avantbras2_base->addChild(iv->avantbras2h_base);
  iv->avantbras2h_translation->translation = SbVec3f(0, -0.03, 0.009);
  iv->avantbras2h_base->addChild(iv->avantbras2h_translation);
  iv->openMember("avantbrashaut_x.wrl", iv->avantbras2h, iv->avantbras2h_base);
  iv->avantbras2_base->addChild(iv->avantbras2b_base);
  iv->avantbras2b_translation->translation = SbVec3f(0, -0.77, 0.009);
  iv->avantbras2b_base->addChild(iv->avantbras2b_translation);
  iv->openMember("avantbrasbas_x.wrl", iv->avantbras2b, iv->avantbras2b_base);

  //biceps3
  iv->biceps3_base->ref();
  iv->separator->addChild(iv->biceps3_base);
  iv->biceps3_init_rotor->rotation.setValue(SbVec3f(0, 1, 0),-2.0943951f);
  iv->biceps3_base->addChild(iv->biceps3_init_rotor);
  iv->biceps3_translation->translation = SbVec3f(0.2f, 0, 0);
  iv->biceps3_base->addChild(iv->biceps3_translation);
  iv->biceps3_base->addChild(iv->biceps3_rotor);
  iv->openMember("rep.wrl", iv->biceps2_repere, iv->biceps2_base);
  iv->openMember("biceps_x.wrl", iv->biceps3, iv->biceps3_base);
  //avantbras3
  iv->avantbras3_base->ref();
  iv->biceps3_base->addChild(iv->avantbras3_base);
  iv->avantbras3_translation->translation = SbVec3f(0.345f, -0.029, 0);
  iv->avantbras3_base->addChild(iv->avantbras3_translation);
  iv->openMember("rep.wrl", iv->avantbras3_repere, iv->avantbras3_base);
    iv->avantbras3_base->addChild(iv->avantbras3_rotor);
    iv->avantbras3_base->addChild(iv->avantbras3g_base);
    iv->avantbras3g_translation->translation = SbVec3f(0, 0, -0.050+0.009);
    iv->avantbras3g_base->addChild(iv->avantbras3g_translation);
    iv->avantbras3g_base->addChild(iv->avantbras3g_rotor2);
    iv->openMember("avantbrasgauche_x.wrl", iv->avantbras3g, iv->avantbras3g_base);
    iv->avantbras3_base->addChild(iv->avantbras3d_base);
    iv->avantbras3d_translation->translation = SbVec3f(0, 0, +0.050+0.009);
    iv->avantbras3d_base->addChild(iv->avantbras3d_translation);
    iv->avantbras3d_base->addChild(iv->avantbras3d_rotor2);
    iv->openMember("avantbrasdroit_x.wrl", iv->avantbras3d, iv->avantbras3d_base);
    iv->avantbras3_base->addChild(iv->avantbras3h_base);
    iv->avantbras3h_translation->translation = SbVec3f(0, -0.03, 0.009);
    iv->avantbras3h_base->addChild(iv->avantbras3h_translation);
    iv->openMember("avantbrashaut_x.wrl", iv->avantbras3h, iv->avantbras3h_base);
    iv->avantbras3_base->addChild(iv->avantbras3b_base);
    iv->avantbras3b_translation->translation = SbVec3f(0, -0.77, 0.009);
    iv->avantbras3b_base->addChild(iv->avantbras3b_translation);
    iv->openMember("avantbrasbas_x.wrl", iv->avantbras3b, iv->avantbras3b_base);
  }

  form1 = new Form1();
  form1->show();
  form1->move(QPoint(10,540));
  form1->lCDNumber1->display(-1.92);

  app.setMainWidget(mw);
  mw->resize(640,480);
  mw->move(QPoint(10,10));
  mw->show();

  iv->mode = 0;
  iv->x_wanted = 0;
  iv->y_wanted = -0.9;
  iv->z_wanted = 0;
  iv->move();

  form1->connect( form1->pushButton1, SIGNAL( clicked() ), iv, SLOT( move() ) );
  form1->connect( form1->checkBox1, SIGNAL( stateChanged(int) ), iv, SLOT( checkBox1_state_changed(int) ) );
  form1->connect( form1->pushButton2, SIGNAL( clicked() ), iv, SLOT( center_scene() ) );
  form1->connect( form1->checkBox1_2_2, SIGNAL( stateChanged(int) ), iv, SLOT(toggle_headlight(int) ) );
  form1->connect( form1->lineEdit1, SIGNAL( textChanged(const QString&) ), iv, SLOT(x_changed(const QString&) ));
  form1->connect( form1->lineEdit2, SIGNAL( textChanged(const QString&) ), iv, SLOT(y_changed(const QString&) ));
  form1->connect( form1->lineEdit3, SIGNAL( textChanged(const QString&) ), iv, SLOT(z_changed(const QString&) ));
  form1->connect( form1->radioButton4, SIGNAL( stateChanged(int) ), iv, SLOT( toggle_moving_mode(int) ));
  form1->connect( form1->radioButton3, SIGNAL( stateChanged(int) ), iv, SLOT( toggle_moving_mode2(int) ));
  form1->connect( form1->slider1, SIGNAL( sliderMoved(int) ), iv, SLOT( move_plateau(int) ));
  form1->connect( form1->pushButton4, SIGNAL( clicked() ), iv, SLOT( lauch_simulation() ));

  SoQt::mainLoop();

  return 0;
}
