#ifndef __PROJET_H__
#define __PROJET_H__

#include <Inventor/nodes/SoSeparator.h>
#include <Inventor/nodes/SoTranslation.h>
#include <Inventor/nodes/SoRotation.h>
#include <Inventor/nodes/SoMaterial.h>
#include <Inventor/nodes/SoDirectionalLight.h>
#include <Inventor/nodes/SoPerspectiveCamera.h>

#include <Inventor/Qt/viewers/SoQtExaminerViewer.h>

#include <qobject.h>

void millisleep( unsigned int milliseconds );

class IVLoader : public QObject
{
  Q_OBJECT
  public :
    IVLoader(QWidget* parent);
    ~IVLoader();
    void openFile(QString s);
    void openMember(QString s, SoSeparator *new_separator, SoSeparator *root);

    //matiere
    SoMaterial *matiere;
    //root
    SoSeparator *separator;
    //top
    SoSeparator *top;
    //item
    SoSeparator *item;
    SoTranslation *item_translation;
    SoSeparator *item_base;
    //plateau
    SoSeparator *plateau;
    SoTranslation *plateau_translation;
    SoSeparator *plateau_base;
    //bottom
    SoTranslation *bottom_translation;
    SoSeparator *bottom_base;
    SoSeparator *bottom;
    //biceps1
    SoTranslation *biceps1_translation;
    SoSeparator *biceps1_base;
    SoSeparator *biceps1_repere;
    SoRotation *biceps1_rotor;
    SoSeparator *biceps1;
    //avantbras1
    SoTranslation *avantbras1_translation;
    SoTranslation *avantbras1g_translation;
    SoTranslation *avantbras1d_translation;
    SoSeparator *avantbras1_base;
    SoSeparator *avantbras1g_base;
    SoSeparator *avantbras1d_base;
    SoSeparator *avantbras1_repere;
    SoRotation *avantbras1_rotor;
    SoRotation *avantbras1g_rotor2;
    SoRotation *avantbras1d_rotor2;
    SoSeparator *avantbras1;
    SoSeparator *avantbras1g;
    SoSeparator *avantbras1d;
    SoSeparator *avantbras1h_base;
    SoTranslation *avantbras1h_translation;
    SoSeparator *avantbras1h;
    SoSeparator *avantbras1b_base;
    SoTranslation *avantbras1b_translation;
    SoSeparator *avantbras1b;
    //biceps2
    SoTranslation *biceps2_translation;
    SoSeparator *biceps2_base;
    SoSeparator *biceps2_repere;
    SoRotation *biceps2_rotor;
    SoRotation *biceps2_init_rotor;
    SoSeparator *biceps2;
    //avantbras2
    SoTranslation *avantbras2_translation;
    SoTranslation *avantbras2g_translation;
    SoTranslation *avantbras2d_translation;
    SoSeparator *avantbras2_base;
    SoSeparator *avantbras2g_base;
    SoSeparator *avantbras2d_base;
    SoSeparator *avantbras2_repere;
    SoRotation *avantbras2_rotor;
    SoRotation *avantbras2g_rotor2;
    SoRotation *avantbras2d_rotor2;
    SoSeparator *avantbras2;
    SoSeparator *avantbras2g;
    SoSeparator *avantbras2d;
    SoSeparator *avantbras2h_base;
    SoTranslation *avantbras2h_translation;
    SoSeparator *avantbras2h;
    SoSeparator *avantbras2b_base;
    SoTranslation *avantbras2b_translation;
    SoSeparator *avantbras2b;
    //biceps3
    SoTranslation *biceps3_translation;
    SoSeparator *biceps3_base;
    SoSeparator *biceps3_repere;
    SoRotation *biceps3_init_rotor;
    SoRotation *biceps3_rotor;
    SoSeparator *biceps3;
    //avantbras3
    SoTranslation *avantbras3_translation;
    SoTranslation *avantbras3g_translation;
    SoTranslation *avantbras3d_translation;
    SoSeparator *avantbras3_base;
    SoSeparator *avantbras3g_base;
    SoSeparator *avantbras3d_base;
    SoSeparator *avantbras3_repere;
    SoRotation *avantbras3_rotor;
    SoRotation *avantbras3g_rotor2;
    SoRotation *avantbras3d_rotor2;
    SoSeparator *avantbras3;
    SoSeparator *avantbras3g;
    SoSeparator *avantbras3d;
    SoSeparator *avantbras3h_base;
    SoTranslation *avantbras3h_translation;
    SoSeparator *avantbras3h;
    SoSeparator *avantbras3b_base;
    SoTranslation *avantbras3b_translation;
    SoSeparator *avantbras3b;

    SoQtExaminerViewer* viewer;

    double last_good_x;
    double last_good_y;
    double last_good_z;
    double x_wanted;
    double x_initial;
    double y_wanted;
    double y_initial;
    double z_wanted;
    double z_initial;

    int mode;
    int simulation_mode;
    bool gotoposition(double x, double y, double z);

    public slots:
      void openFileDialog();
      void move();
      void checkBox1_state_changed(int state);
      void toggle_simulation_mode(int state);
      void center_scene();
      void toggle_headlight(int state);
      void toggle_moving_mode(int state);
      void toggle_moving_mode2(int state);
      void move_plateau(int val);
      void x_changed(const QString& text);
      void y_changed(const QString& text);
      void z_changed(const QString& text);
      void lauch_simulation();

};

void move_progressif(double x_initial, double x_wanted, double y_initial, double y_wanted, double z_initial, double z_wanted, IVLoader *ivv);
void move_progressif_item(double x_initial, double x_wanted, double y_initial, double y_wanted, double z_initial, double z_wanted, IVLoader *ivv);
void move_progressif_both(double x_initial, double x_wanted, double y_initial, double y_wanted, double z_initial, double z_wanted, IVLoader *ivv);
void move_progressif_item_only(double x_initial, double x_wanted, double y_initial, double y_wanted, double z_initial, double z_wanted, IVLoader *ivv);
 
#endif //__PROJET_H__
